﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@model Toyota.Common.Web.MVC.ModelHolder

@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        font-weight: bold;
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px;}
}

@section StartupScript {
    @*ForecastDetailView.Refresh();*@

    $('#FMProductionMonthText_I').monthpicker({
        startYear: new Date().getFullYear() - 5,
        finalYear: new Date().getFullYear() + 1,
        pattern: 'mmm yyyy', 
        monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    });

    $('#FMProductionMonthText_I').bind('onchange',function(e){
        alert("input change");
    });

    Date.isLeapYear = function (year) {
        return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
    };

    Date.getDaysInMonth = function (year, month) {
        return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
    };

    Date.prototype.isLeapYear = function () {
        return Date.isLeapYear(this.getFullYear());
    };

    Date.prototype.getDaysInMonth = function () {
        return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
    };

    Date.prototype.addMonths = function (value) {
        var n = this.getDate();
        this.setDate(1);
        this.setMonth(this.getMonth() + value);
        this.setDate(Math.min(n, this.getDaysInMonth()));
        return this;
    };


    var today = new Date().addMonths(2); 
    productionMonth = today.getFullYear() + pad(today.getMonth()).toString();
    FMProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);

    //GridFHSupplierIDOption.PerformCallback();
}

<script>

    var isSearch = 'Y';

    function pad(n) {
        return (n < 10) && (n >= 0) ? ("0" + n) : n;
    }

    function GetRegularProductionMonth(productionMonth) {
        var year = String(productionMonth).substring(0, 4);
        var month = String(productionMonth).substring(String(productionMonth).length, String(productionMonth).length - 2);
        var monthEnum = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'
        };

        return monthEnum[month] + " " + year;
    }

    function GetProductionMonth(productionMonth) {
        var paramStr = String(productionMonth).replace(' ', '');
        var paramStrLength = String(paramStr).length;

        var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
        var month = String(paramStr).substring(0, paramStrLength - 4);
        var monthEnum = {
            January: '01',
            February: '02',
            March: '03',
            April: '04',
            May: '05',
            June: '06',
            July: '07',
            August: '08',
            September: '09',
            October: '10',
            November: '11',
            December: '12'
        };
        var monthNum = "";
        if (Boolean(month))
            monthNum = monthEnum[month];

        return year + monthNum;
    }

    function OnBeginCallbackGrid(s, e) {

        PopupProgressDownload.Show();

        e.customArgs["PROD_MONTH"] = GetProductionMonth(FMProductionMonthText.GetText());
        e.customArgs["TIMING"] = FMTimingText.GetValue();
        e.customArgs["CATEGORY"] = FMCategoryText.GetText();
        e.customArgs["SUPPLIER"] = FMSupplierGrid.GetText();
        e.customArgs["isSearch"] = isSearch;
    }

    function OnEndCallbackGrid(s, e) {
        PopupProgressDownload.Hide();
        getMessage();

        if (FMGrid.GetVisibleRowsOnPage() > 0)
            DJDownloadButton.SetEnabled(true);
        else
            DJDownloadButton.SetEnabled(false);

    }

    function getMessage() {
        PopupProgressDownload.Hide();
        setTimeout(function () {

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/FluctuationMonitoring/GetMessage")",
                data: {},
                success: function (result) {
                    if (result.length > 0) {
                        $.msgBox({ title: "Error", type: "error", content: result });
                    }
                    PopupProgressDownload.Hide();
                },
                error: function (result) {
                    console.log(result);
                }
            });
        }, 500);
    }

    function onClickSearch() {
        isSearch = 'Y';

        FMGrid.PerformCallback();

    }

    function onClickClear() {
        isSearch = 'N';
        var today = new Date();

        var today = new Date().addMonths(2);
        productionMonth = today.getFullYear() + pad(today.getMonth()).toString();
        FMProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);

        FMCategoryText.SetValue('');
        FMTimingText.SetValue('');
        FMSupplierGrid.SetValue('');
        GridFMSupplierGrid.UnselectAllRowsOnPage();

        FMGrid.ClearFilter();

        getMessage();
    }

    function onClickDownload() {
        var prod_month = GetProductionMonth(FMProductionMonthText.GetText());
        var timing = FMTimingText.GetValue();
        var category = FMCategoryText.GetText();
        var supplier = FMSupplierGrid.GetText();

        PopupProgressDownload.Show();

        $.fileDownload("FluctuationMonitoring/DownloadFluctuation/", {
            data: {
                PROD_MONTH: prod_month,
                TIMING: timing === "null" ? "" : timing,
                SUPPLIER: supplier === "null" ? "" : supplier,
                CATEGORY: category === "null" ? "" : category
            },
            successCallback: function (result) {
                //$.msgBox({ title: "info", type: "info", content: 'File Downloaded' });
                PopupProgressDownload.Hide();
            },
            failCallback: function (result) {
                $.msgBox({ title: "Error", type: "error", content: result });
            }
        });
    }
</script>

<div style="display:table; border:1px solid #142B94; background-color:#DEECFD; padding:10px">
    @Html.Action("FluctuationHeaderCriteria", "FluctuationMonitoring")
</div>
<div style="height: 15px;"></div>
<div>
    @Html.Action("FluctuationGrid", "FluctuationMonitoring")
</div>

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "PopupProgressDownload";
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.ShowShadow = true;
    settings.Modal = true;
    settings.CloseAction = CloseAction.None;
    settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupProgressDownload");
    });
}).GetHtml()